# Aura OS Makefile
# 

OBJ_LIST1 = \
$(OBJ_DIR)/main.o \
$(OBJ_DIR)/debug.o \
$(OBJ_DIR)/vfile.o \
$(OBJ_DIR)/registry.o \
$(OBJ_DIR)/ini.o \
$(OBJ_DIR)/screen.o \
$(OBJ_DIR)/metrics.o \
$(OBJ_DIR)/mouse.o \
$(OBJ_DIR)/keyboard.o \
$(OBJ_DIR)/tasks.o \
$(OBJ_DIR)/events.o \
$(OBJ_DIR)/exports.o \
$(OBJ_DIR)/image.o \
$(OBJ_DIR)/text.o \
$(OBJ_DIR)/list.o \
$(OBJ_DIR)/resource.o \
$(OBJ_DIR)/error.o \
$(OBJ_DIR)/timer.o \
$(OBJ_DIR)/thread.o \
$(OBJ_DIR)/font.o \
$(OBJ_DIR)/utext.o \
$(OBJ_DIR)/vfile/root.o \
$(OBJ_DIR)/dms/generic.o \
$(OBJ_DIR)/grfx2.o \
$(OBJ_DIR)/dms2.o \
$(OBJ_DIR)/dynld.o

APPOBJ = \
$(OBJ_DIR)/applications/desktop.o \
$(OBJ_DIR)/applications/nav.o \
$(OBJ_DIR)/applications/calc.o \
$(OBJ_DIR)/applications/snote.o \
$(OBJ_DIR)/applications/typewriter.o \
$(OBJ_DIR)/applications/regedit.o \
$(OBJ_DIR)/applications/immagine.o \
$(OBJ_DIR)/applications/setscr.o \
$(OBJ_DIR)/applications/setmouse.o \
$(OBJ_DIR)/applications/resedit.o \
$(OBJ_DIR)/applications/about.o \
$(OBJ_DIR)/applications/kedit.o \
$(OBJ_DIR)/applications/setkeyb.o \
$(OBJ_DIR)/applications/setwall.o \
$(OBJ_DIR)/applications/settheme.o \
$(OBJ_DIR)/applications/console.o \
$(OBJ_DIR)/applications/rundos.o \
$(OBJ_DIR)/applications/dfmsinfo.o \
$(OBJ_DIR)/applications/openwth.o \
$(OBJ_DIR)/applications/xsystem.o \
$(OBJ_DIR)/applications/ssplay.o \
$(OBJ_DIR)/applications/setvol.o \
$(OBJ_DIR)/applications/setlib.o \
$(OBJ_DIR)/applications/imgor.o \
$(OBJ_DIR)/applications/run.o \
$(OBJ_DIR)/applications/ttt.o \
$(OBJ_DIR)/applications/setup.o \
$(OBJ_DIR)/applications/welcome.o \
$(OBJ_DIR)/applications/batchinator.o \
$(OBJ_DIR)/xapps/myip.o \
$(OBJ_DIR)/xapps/htmlget.o

APPLD = \
bin/applications/desktop.app \
bin/applications/nav.app \
bin/applications/calc.app \
bin/applications/snote.app \
bin/applications/typewriter.app \
bin/applications/regedit.app \
bin/applications/immagine.app \
bin/applications/setscr.app \
bin/applications/setmouse.app \
bin/applications/resedit.app \
bin/applications/about.app \
bin/applications/kedit.app \
bin/applications/setkeyb.app \
bin/applications/setwall.app \
bin/applications/settheme.app \
bin/applications/console.app \
bin/applications/rundos.app \
bin/applications/dfmsinfo.app \
bin/applications/openwth.app \
bin/applications/xsystem.app \
bin/applications/ssplay.app \
bin/applications/setvol.app \
bin/applications/setlib.app \
bin/applications/imgor.app \
bin/applications/run.app \
bin/applications/ttt.app \
bin/applications/setup.app \
bin/applications/welcome.app \
bin/applications/batchinator.app \
bin/xapps/myip.app \
bin/xapps/htmlget.app

LIBOBJ = \
$(OBJ_DIR)/libraries/widget.o \
$(OBJ_DIR)/libraries/widget/iwidget.o \
$(OBJ_DIR)/libraries/widget/wclass.o \
$(OBJ_DIR)/libraries/widget/spliter.o \
$(OBJ_DIR)/libraries/skin.o \
$(OBJ_DIR)/libraries/bmp.o \
$(OBJ_DIR)/libraries/button.o \
$(OBJ_DIR)/libraries/label.o \
$(OBJ_DIR)/libraries/progress.o \
$(OBJ_DIR)/libraries/checkbox.o \
$(OBJ_DIR)/libraries/clipbrd.o \
$(OBJ_DIR)/libraries/window.o \
$(OBJ_DIR)/libraries/menu.o \
$(OBJ_DIR)/libraries/scrllbar.o \
$(OBJ_DIR)/libraries/listbox.o \
$(OBJ_DIR)/libraries/textbox.o \
$(OBJ_DIR)/libraries/canvas.o \
$(OBJ_DIR)/libraries/treeview.o \
$(OBJ_DIR)/libraries/groupbox.o \
$(OBJ_DIR)/libraries/slider.o \
$(OBJ_DIR)/libraries/listview.o \
$(OBJ_DIR)/libraries/iodlg.o \
$(OBJ_DIR)/libraries/combobox.o \
$(OBJ_DIR)/libraries/fprop.o \
$(OBJ_DIR)/libraries/tabbook.o \
$(OBJ_DIR)/libraries/cp.o \
$(OBJ_DIR)/libraries/toolbar.o \
$(OBJ_DIR)/libraries/prevscr.o \
$(OBJ_DIR)/libraries/conlib.o \
$(OBJ_DIR)/libraries/colsel.o \
$(OBJ_DIR)/libraries/fms2.o \
$(OBJ_DIR)/libraries/sound.o \
$(OBJ_DIR)/libraries/memfile.o \
$(OBJ_DIR)/libraries/grfx.o 

LIBLD = \
bin/system/lib/widget.dl \
bin/system/lib/skin.dl \
bin/system/lib/bmp.dl \
bin/system/lib/clipbrd.dl \
bin/system/lib/button.dl \
bin/system/lib/label.dl \
bin/system/lib/progress.dl \
bin/system/lib/checkbox.dl \
bin/system/lib/window.dl \
bin/system/lib/menu.dl \
bin/system/lib/scrllbar.dl \
bin/system/lib/listbox.dl \
bin/system/lib/textbox.dl \
bin/system/lib/canvas.dl \
bin/system/lib/treeview.dl \
bin/system/lib/groupbox.dl \
bin/system/lib/slider.dl \
bin/system/lib/listview.dl \
bin/system/lib/iodlg.dl \
bin/system/lib/combobox.dl \
bin/system/lib/fprop.dl \
bin/system/lib/tabbook.dl \
bin/system/lib/cp.dl \
bin/system/lib/toolbar.dl \
bin/system/lib/png.dl \
bin/system/lib/mpeg2.dl \
bin/system/lib/prevscr.dl \
bin/system/lib/conlib.dl \
bin/system/lib/colsel.dl \
bin/system/lib/fms2.dl \
bin/system/lib/grfx.dl \
bin/system/lib/sound.dl \
bin/system/lib/mp3.dl \
bin/system/lib/memfile.dl \
bin/system/lib/jpg.dl  

JPGOBJ = obj/dms/jpg/jpgalleg.o obj/dms/jpg/io.o obj/dms/jpg/encode.o obj/dms/jpg/decode.o obj/dms/jpg/color.o

PNGOBJ = obj/dms/png/png.o \
obj/dms/png/pngset.o \
obj/dms/png/pngget.o \
obj/dms/png/pngrutil.o \
obj/dms/png/pngtrans.o \
obj/dms/png/pngwutil.o \
obj/dms/png/pngread.o \
obj/dms/png/pngrio.o \
obj/dms/png/pngwio.o \
obj/dms/png/pngwrite.o \
obj/dms/png/pngrtran.o \
obj/dms/png/pngwtran.o \
obj/dms/png/pngmem.o \
obj/dms/png/pngerror.o \
obj/dms/png/pngpread.o \
obj/libraries/png.o

MP3OBJ=obj/dms/mp3/decoder/layer2.o \
obj/dms/mp3/decoder/layer3.o \
obj/dms/mp3/decoder/interface.o \
obj/dms/mp3/decoder/decode_i386.o \
obj/dms/mp3/decoder/dct64_i386.o \
obj/dms/mp3/decoder/common.o \
obj/dms/mp3/mp3.o \
obj/dms/mp3/decoder/tabinit.o

TCPOBJ=obj/dms/tcp/BSDNAME.O \
obj/dms/tcp/ELIB.O \
obj/dms/tcp/FRAGMENT.O \
obj/dms/tcp/INCHKSUM.O \
obj/dms/tcp/INTEL.O \
obj/dms/tcp/PCARP.O \
obj/dms/tcp/PCBOOTP.O \
obj/dms/tcp/PCBSD.O \
obj/dms/tcp/PCBUF.O \
obj/dms/tcp/PCCONFIG.O \
obj/dms/tcp/PCDBUG.O \
obj/dms/tcp/PCICMP.O \
obj/dms/tcp/PCPING.O \
obj/dms/tcp/PCPKT.O \
obj/dms/tcp/PCRECV.O \
obj/dms/tcp/PCSED.O \
obj/dms/tcp/PCSTAT.O \
obj/dms/tcp/PCTCP.O \
obj/dms/tcp/SELECT.O \
obj/dms/tcp/SOCKET.O \
obj/dms/tcp/SOCK_DBU.O \
obj/dms/tcp/SOCK_INI.O \
obj/dms/tcp/SOCK_PRN.O \
obj/dms/tcp/TEST.O \
obj/dms/tcp/UDP_DOM.O \
obj/dms/tcp/UDP_NDS.O \
obj/dms/tcp/VSSCANF.O \
obj/dms/tcp/KBHIT.O \
obj/dms/tcp/_MODDI3.O \
obj/dms/watt/netaddr.o \
obj/dms/watt/neterr.o \
obj/dms/watt/getopt.o \
obj/dms/watt/sock_ini.o \
obj/dms/watt/lookup.o \
obj/dms/watt/misc.o \
obj/dms/watt/version.o \
obj/dms/tcp/_DIVDI3.O

WATTOBJ=obj/dms/watt/chksum0.o \
obj/dms/watt/cpumodel.o \
obj/dms/watt/accept.o \
obj/dms/watt/adr2asc.o \
obj/dms/watt/asc2adr.o \
obj/dms/watt/bind.o \
obj/dms/watt/bsddbug.o \
obj/dms/watt/bsdname.o \
obj/dms/watt/btree.o \
obj/dms/watt/chksum.o \
obj/dms/watt/close.o \
obj/dms/watt/connect.o \
obj/dms/watt/country.o \
obj/dms/watt/crc.o \
obj/dms/watt/echo.o \
obj/dms/watt/fcntl.o \
obj/dms/watt/fortify.o \
obj/dms/watt/get_ai.o \
obj/dms/watt/get_ni.o \
obj/dms/watt/geteth.o \
obj/dms/watt/gethost.o \
obj/dms/watt/gethost6.o \
obj/dms/watt/getname.o \
obj/dms/watt/getnet.o \
obj/dms/watt/getopt.o \
obj/dms/watt/getprot.o \
obj/dms/watt/getput.o \
obj/dms/watt/getserv.o \
obj/dms/watt/gettod.o \
obj/dms/watt/ioctl.o \
obj/dms/watt/ip4_frag.o \
obj/dms/watt/ip4_in.o \
obj/dms/watt/ip4_out.o \
obj/dms/watt/ip6_in.o \
obj/dms/watt/ip6_out.o \
obj/dms/watt/language.o \
obj/dms/watt/linkaddr.o \
obj/dms/watt/listen.o \
obj/dms/watt/lookup.o \
obj/dms/watt/loopback.o \
obj/dms/watt/misc.o \
obj/dms/watt/netaddr.o \
obj/dms/watt/netback.o \
obj/dms/watt/neterr.o \
obj/dms/watt/nettime.o \
obj/dms/watt/nsapaddr.o \
obj/dms/watt/oldstuff.o \
obj/dms/watt/pc_cbrk.o \
obj/dms/watt/pcarp.o \
obj/dms/watt/pcbootp.o \
obj/dms/watt/powerpak.o \
obj/dms/watt/pcbuf.o \
obj/dms/watt/pcconfig.o \
obj/dms/watt/pcdbug.o \
obj/dms/watt/pcdhcp.o \
obj/dms/watt/pcicmp.o \
obj/dms/watt/pcicmp6.o \
obj/dms/watt/pcintr.o \
obj/dms/watt/pcmulti.o \
obj/dms/watt/pcping.o \
obj/dms/watt/pcpkt.o \
obj/dms/watt/pcpkt32.o \
obj/dms/watt/pcqueue.o \
obj/dms/watt/pcrarp.o \
obj/dms/watt/pcrecv.o \
obj/dms/watt/pcsed.o \
obj/dms/watt/pcstat.o \
obj/dms/watt/pctcp.o \
obj/dms/watt/poll.o \
obj/dms/watt/ports.o \
obj/dms/watt/ppp.o \
obj/dms/watt/pppoe.o \
obj/dms/watt/presaddr.o \
obj/dms/watt/printk.o \
obj/dms/watt/qmsg.o \
obj/dms/watt/receive.o \
obj/dms/watt/res_comp.o \
obj/dms/watt/res_data.o \
obj/dms/watt/res_debu.o \
obj/dms/watt/res_init.o \
obj/dms/watt/res_loc.o \
obj/dms/watt/res_mkqu.o \
obj/dms/watt/res_quer.o \
obj/dms/watt/res_send.o \
obj/dms/watt/select.o \
obj/dms/watt/settod.o \
obj/dms/watt/shutdown.o \
obj/dms/watt/signal.o \
obj/dms/watt/sock_dbu.o \
obj/dms/watt/sock_in.o \
obj/dms/watt/sock_ini.o \
obj/dms/watt/sock_io.o \
obj/dms/watt/sock_prn.o \
obj/dms/watt/sock_scn.o \
obj/dms/watt/sock_sel.o \
obj/dms/watt/socket.o \
obj/dms/watt/sockopt.o \
obj/dms/watt/split.o \
obj/dms/watt/stream.o \
obj/dms/watt/strings.o \
obj/dms/watt/syslog.o \
obj/dms/watt/syslog2.o \
obj/dms/watt/tcp_fsm.o \
obj/dms/watt/get_xbyr.o \
obj/dms/watt/tftp.o \
obj/dms/watt/timer.o \
obj/dms/watt/transmit.o \
obj/dms/watt/udp_dom.o \
obj/dms/watt/udp_rev.o \
obj/dms/watt/version.o \
obj/dms/watt/fsext.o \
obj/dms/watt/wdpmi.o \
obj/dms/watt/x32vm.o \
obj/dms/watt/rs232.o \
obj/dms/watt/get_ip.o \
obj/dms/watt/pcsarp.o \
obj/dms/watt/idna.o \
obj/dms/watt/punycode.o \
obj/dms/watt/tcp_md5.o \
obj/dms/watt/dynip.o \
obj/dms/watt/winpcap.o \
obj/dms/watt/winmisc.o \
obj/dms/watt/packet32.o \
obj/dms/watt/adler32.o \
obj/dms/watt/compress.o \
obj/dms/watt/crc32.o \
obj/dms/watt/gzio.o \
obj/dms/watt/uncompr.o \
obj/dms/watt/deflate.o \
obj/dms/watt/trees.o \
obj/dms/watt/zutil.o \
obj/dms/watt/inflate.o \
obj/dms/watt/infback.o \
obj/dms/watt/inftrees.o \
obj/dms/watt/inffast.o

MPEGOBJ=obj/dms/mpeg2/mpeg2.o 


all : $(OBJ_DIR)/dynldlnk.o $(DYNLDLNK) $(LIBOBJ) $(LIBLD) $(APPOBJ) $(APPLD) $(OBJ_LIST1) $(OBJ_LIST2) $(MAIN)
	@echo Aura OS has been built.

$(DYNLDLNK) : obj/dynldlnk.o
	gcc -g -o $(DYNLDLNK) obj/dynldlnk.o $(LIB_DYNLNK)

$(MAIN) : $(OBJ_LIST1) $(OBJ_LIST2)
	gcc -g -o $(MAIN) $(OBJ_LIST1) $(OBJ_LIST2) $(LIB_LIST)

$(OBJ_DIR)/libraries/%.o: src/libraries/%.c
	gcc $(CFLAGS) -c $< -o $@

$(OBJ_DIR)/applications/%.o: src/applications/%.c
	gcc $(CFLAGS) -c $< -o $@

$(OBJ_DIR)/libraries/%.o: src/dms/%.c
	gcc $(CFLAGS) -c $< -o $@

$(OBJ_DIR)/libraries/widget/%.o: src/dms/widget/%.c
	gcc $(CFLAGS) -c $< -o $@

$(OBJ_DIR)/vfile/%.o: src/vfile/%.c
	gcc $(CFLAGS) -c $< -o $@

$(OBJ_DIR)/%.o: src/%.c
	gcc $(CFLAGS) -c $< -o $@

bin/applications/%.app: $(OBJ_DIR)/applications/%.o
	$(DYNLDLNK) $@ $<

obj/dms/png/%.o: src/dms/png/%.c
	gcc $(CFLAGS) -c $< -o $@

obj/dms/mpeg2/%.o: src/dms/mpeg2/%.c
	gcc $(CFLAGS) -c $< -o $@


obj/dms/mp3/decoder/%.o: src/dms/mp3/decoder/%.c
	gcc $(CFLAGS) -c $< -o $@

obj/dms/mp3/%.o: src/dms/mp3/%.c
	gcc $(CFLAGS) -c $< -o $@

obj/dms/jpg/%.o: src/dms/jpg/%.c
	gcc $(CFLAGS) -c $< -o $@

obj/dms/jpg/%.o: src/dms/jpg/i386/%.s
	$(CC) -g -x assembler-with-cpp -Iinclude -c $< -o $@

bin/system/lib/jpg.dl: $(JPGOBJ)
	$(DYNLDLNK) bin/system/lib/jpg.dl $(JPGOBJ)

bin/system/lib/mp3.dl: $(MP3OBJ)
	$(DYNLDLNK) bin/system/lib/mp3.dl $(MP3OBJ)

bin/system/lib/png.dl: $(PNGOBJ)
	$(DYNLDLNK) bin/system/lib/png.dl $(PNGOBJ)

bin/system/lib/mpeg2.dl: $(MPEGOBJ)
	$(DYNLDLNK) bin/system/lib/mpeg2.dl $(MPEGOBJ)


bin/applications/setscr.app: $(OBJ_DIR)/applications/setscr.o res/setscr.res
	$(DYNLDLNK) -Rres/setscr.res bin/applications/setscr.app $(OBJ_DIR)/applications/setscr.o

bin/applications/ssplay.app: $(OBJ_DIR)/applications/ssplay.o res/ssplay.res
	$(DYNLDLNK) -Rres/ssplay.res bin/applications/ssplay.app $(OBJ_DIR)/applications/ssplay.o

bin/applications/run.app: $(OBJ_DIR)/applications/run.o res/run.res
	$(DYNLDLNK) -Rres/run.res bin/applications/run.app $(OBJ_DIR)/applications/run.o

bin/applications/console.app: $(OBJ_DIR)/applications/console.o res/cons.res
	$(DYNLDLNK) -Rres/cons.res bin/applications/console.app $(OBJ_DIR)/applications/console.o

bin/applications/about.app: $(OBJ_DIR)/applications/about.o res/about.res
	$(DYNLDLNK) -Rres/about.res bin/applications/about.app $(OBJ_DIR)/applications/about.o

bin/applications/welcome.app: $(OBJ_DIR)/applications/welcome.o res/welcome.res
	$(DYNLDLNK) -Rres/welcome.res bin/applications/welcome.app $(OBJ_DIR)/applications/welcome.o

bin/applications/setup.app: $(OBJ_DIR)/applications/setup.o res/setup.res
	$(DYNLDLNK) -Rres/setup.res bin/applications/setup.app $(OBJ_DIR)/applications/setup.o

bin/applications/imgor.app: $(OBJ_DIR)/applications/imgor.o res/imgor.res
	$(DYNLDLNK) -Rres/imgor.res bin/applications/imgor.app $(OBJ_DIR)/applications/imgor.o

bin/xapps/myip.app: $(OBJ_DIR)/xapps/myip.o 
	$(DYNLDLNK) bin/xapps/myip.app $(OBJ_DIR)/xapps/myip.o

bin/xapps/htmlget.app: $(OBJ_DIR)/xapps/htmlget.o
	$(DYNLDLNK) bin/xapps/htmlget.app $(OBJ_DIR)/xapps/htmlget.o

bin/system/lib/fms2.dl: $(OBJ_DIR)/libraries/fms2.o res/fms2.res
	$(DYNLDLNK) -Rres/fms2.res bin/system/lib/fms2.dl $(OBJ_DIR)/libraries/fms2.o

bin/system/lib/prevscr.dl: $(OBJ_DIR)/libraries/prevscr.o res/prvscr.res
	$(DYNLDLNK) -Rres/prvscr.res bin/system/lib/prevscr.dl $(OBJ_DIR)/libraries/prevscr.o

bin/system/lib/cp.dl: $(OBJ_DIR)/libraries/cp.o res/cp.res
	$(DYNLDLNK) -Rres/cp.res bin/system/lib/cp.dl $(OBJ_DIR)/libraries/cp.o

bin/system/lib/widget.dl: $(OBJ_DIR)/libraries/widget.o $(OBJ_DIR)/libraries/widget/iwidget.o $(OBJ_DIR)/libraries/widget/wclass.o $(OBJ_DIR)/libraries/widget/spliter.o
	$(DYNLDLNK) bin/system/lib/widget.dl $(OBJ_DIR)/libraries/widget.o $(OBJ_DIR)/libraries/widget/iwidget.o $(OBJ_DIR)/libraries/widget/wclass.o $(OBJ_DIR)/libraries/widget/spliter.o

bin/system/lib/%.dl: $(OBJ_DIR)/libraries/%.o
	$(DYNLDLNK) $@ $<

clean:
	$(REMOVE) $(OBJ_DIR)/*.o
	$(REMOVE) $(OBJ_DIR)/libraries/*.o
	$(REMOVE) $(OBJ_DIR)/libraries/widget/*.o
	$(REMOVE) $(OBJ_DIR)/applications/*.o
	$(REMOVE) $(OBJ_DIR)/dms/*.o
	$(REMOVE) $(OBJ_DIR)/dms/png/*.o
	$(REMOVE) $(OBJ_DIR)/dms/jpg/*.o
	$(REMOVE) $(OBJ_DIR)/dms/jpg/*.o
	$(REMOVE) $(OBJ_DIR)/dms/mp3/*.o
	$(REMOVE) $(OBJ_DIR)/dms/mp3/decoder*.o
	$(REMOVE) $(OBJ_DIR)/vfile/*.o
	$(REMOVE) bin/applications/*.app
	$(REMOVE) bin/system/lib/*.dl
