(*
//----------------------------------------------------------------------------
//
// ALLEGTTF - TTF fonts for Allegro
//
// Douglas Eleveld (D.J.Eleveld@anest.azg.nl)
//
//----------------------------------------------------------------------------
*)
unit allegttf;

interface

uses
  ctypes;

{$I allegro.inc}
{$i cdefs.inc}

{$ifdef LINK_CLIBS}

{$endif}

(*----------------------------------------------------------------------------*)
(* Version Info *)
const
 ALLEGTTF_VERSION        =  2;
 ALLEGTTF_SUB_VERSION    =  0;
 ALLEGTTF_VERSION_STR    =  '2.0';
 ALLEGTTF_DATE_STR       =  'June 2001';
 ALLEGTTF_DATE           =  20010601;

(*-----------------------------------------------------------------------------*)
(* Startup and shutdown stuff *)
procedure antialias_init (var pal: RGB);        {$ifdef LINK_CLIBS}external;{$endif}
procedure antialias_palette (var pal: RGB);     {$ifdef LINK_CLIBS}external;{$endif}
procedure antialias_exit ();                    {$ifdef LINK_CLIBS}external;{$endif}

(*-----------------------------------------------------------------------------*)
(* The basic antialiased textout stuff *)
procedure aatextout (bmp:PBITMAP; AL_CONST FONT *font, AL_CONST char *string, x, y, colour: Integer);
{$ifdef LINK_CLIBS}external;{$endif}
procedure aatextout_center (bmp:PBITMAP; AL_CONST FONT *font, AL_CONST char *string, x, y, colour: Integer);
{$ifdef LINK_CLIBS}external;{$endif}
procedure aatextout_right (bmp:PBITMAP; AL_CONST FONT *font, AL_CONST char *string, x, y, colour: Integer);
{$ifdef LINK_CLIBS}external;{$endif}

//* These functions are almost directly from Allegro */
procedure aatextprintf(bmp:PBITMAP; AL_CONST FONT *f, int x, int y, int color, AL_CONST char *format, args: {$ifdef OPascal}array of const{$else}PString{$endif});
{$ifdef LINK_CLIBS}external;{$endif}
procedure aatextprintf_center(bmp:PBITMAP; AL_CONST FONT *f, int x, int y, int color, AL_CONST char *format, args: array of {$ifdef OPascal}const{$else}PString{$endif});
{$ifdef LINK_CLIBS}external;{$endif}
procedure aatextprintf_right(bmp:PBITMAP; AL_CONST FONT *f, int x, int y, int color, AL_CONST char *format, args: array of {$ifdef OPascal}const{$else}PString{$endif});
{$ifdef LINK_CLIBS}external;{$endif}


 {*-----------------------------------------------------------------------------*}
 { * Font loading handling stuff * }

 { * Simply load a font * }
 function Load_font (const c: PChar): PFont;

 { * Load a font and tell us if it is antialiased or not * }
 function load_font2 (const c: PChar; antialiased: PInteger): PFont;

 { * Possible types of font smoothing *}

const
 ALLEGTTF_NOSMOOTH   = 0;
 ALLEGTTF_TTFSMOOTH  = 1;
 ALLEGTTF_REALSMOOTH = 2;

//* Load a font froma bitmap file */
function load_font(filename: String): TFont; {$ifdef LINK_CLIBS}external;{$endif}


//* Load a ttf font from a file */
function load_ttf_font_ex (const filename: String;
                        const points_w: Integer;
                        const points_h: Integer;
                        const smooth: Integer): TFont; {$ifdef LINK_CLIBS}external;{$endif}

//* Load a ttf font from a file */
function load_ttf_font_ex2 (const filename: String;
                         const points_w: Integer;
                         const points_h: Integer;
                         const abegin  : Integer;
                         const aend    : Integer;
                         const smooth  : Integer): TFont; {$ifdef LINK_CLIBS}external;{$endif}
                        
//* Load a ttf font from a file */
function load_ttf_font (const filename: String;
                     const points: Integer;
                     const smooth: Integer): TFont; {$ifdef LINK_CLIBS}external;{$endif}


//* Load a ttf font from a file using TTF2PCX on the path, saves memory! */
function load_ttf_font_ex2_mem (const filename: String;
                                    const pw: Integer;
                                    const ph: Integer;
                                    const abegin: Integer;
                                    const aend: Integer;
                                    const smooth: Integer): TFont; {$ifdef LINK_CLIBS}external;{$endif}
                                    
function load_ttf_font_ex_mem (const filename: String;
                                   const pw: Integer;
                                   const ph: Integer;
                                   const smooth: Integer): TFont; {$ifdef LINK_CLIBS}external;{$endif}
                                   
function load_ttf_font_mem (const filename: String;
                                const points: Integer;
                                const smooth: Integer): TFont; {$ifdef LINK_CLIBS}external;{$endif}


implementation
{$IFNDEF LINK_CLIBS}

{$ENDIF}
end.
