unit button;

interface

uses ctypes, Types;

{$I widget.inc}


//******************************
//	@addtogroup button
//	@{
//
//
//	@file
//	Button widget header file.
//******************************

//#define BUTTON(w) ((PButton)(w))

const
 BS_OVER	=	1;
 BS_DOWN	=	2;


type 
  TButton = record

	o: TWidget;

	Caption: l_text; ///< Caption
	
	Message: l_ulong; ///< Message send when clicked
    MessageExtra: Pointer; ///< Extra value send with message when clicked
	
	(*
		Facultative bitmap drawn on button
		@note By default, icon is on the left of the text, whole content is center
		@see buttonflags
	*)
	
	Icon: p_bitmap;
	
	State: l_ushort;
	
	(*
		Button flags
		@see buttonflags
	*)
	Flags: l_ushort;
  end;
  PButton = ^TButton;

function CreateButton( app: PApplication; r: TRect; Caption: l_text; Message: l_ulong ): PButton;
procedure ButtonSetCaption ( b: PButton; Caption: l_text );
procedure ButtonSetCaptionEx ( b: PButton; Format: l_text; arg1:String=''; arg2:String=''; arg3:String='' );


(* @defgroup buttonflags Buttons flags
	Values that can be set into TButton Flags field.
	Use 'OR' to associate those flags.
	@see CreateButton
	@see TButton
	@{
*)
const
 BF_TEXTUNDERICON =	$00000001; ///< If icon is set, draw the text under the icon and center both of them
 BF_DISABLED	  =	$00000002; ///< Disable the button, and if an icon is set, draw icon in grey
 BF_ALIGNLEFT	  =	$00000004; ///< If icon is set, draw icon on left and draw text on the right of the icon

implementation



end.

