////////////////////////////////////////////////////////////////////////////////
//
//    List Manager - Header file  --- list.h
//
//  (c) Copyright 2003 Point Mad. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

{ .#ifndef _LIST_H_INCLUDED_}
{ .#define _LIST_H_INCLUDED_}

///**
//	@addtogroup list
//	@{
//*/

///**	@file
//	List Header file.
//	Declarations and inlines functions.
//*/

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Hier beginnt eine neue Implementation der Listen
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
type
  PBList = TList;
  PSList = PBList;
  PBListItem = ^TBListItem;
  PSListItem = ^TSListItem;
  TBListItem = class(TObject)
  private
    FNext: PSListItem;
    FPrev: PSListItem;
  public
    constructor Create;
    destructor Destroy; override;
  end;

  TSListItem = class(TObject)
  private
    FData: Pointer;
    FLink: TBListItem;
    function GetData: Pointer;
    procedure SetData(Value: Pointer);
  public
    constructor Create;
    destructor Destroy; override;
    property Data: Pointer read GetData write SetData;
  end;

function BListAddItem ( o: PBList; i: PBListItem ): PBListItem;
procedure BListRemoveItemEx ( o: PBList; i: PBListItem );
procedure FreeSList ( o: PBList; FreeData: FreeProc );
function NewBList ( ): PBList;
function SListAdd ( o: PBList; var Data ): PSListItem;
function SListFoundItem ( o: PBList; var Data ): PSListItem;


//implementation

function BListAddItem ( o: PBList; i: PBListItem ): PBListItem;
begin

end;

procedure BListRemoveItemEx ( o: PBList; i: PBListItem );
begin

end;

procedure FreeSList ( o: PBList; FreeData: FreeProc );
begin

end;
  
function NewBList: PBList;  
var List: PBList;
begin
  Result := PBList.Create;
end;

function SListAdd ( o: PBList; var Data ): PSListItem;
var
  LItem: TSListItem;
begin
  LItem := TSLitItem.Create;
  LItem.Data := Pointer(Data);
  Result := @LItem;
end;

function SListFoundItem ( o: PBList; var Data ): PSListItem;
begin

end;


{ TBListItem }
  
constructor TBListItem.Create;
begin
  inherited Create;
  
end;

destructor TBListItem.Destroy; 
begin

  inherited Destroy;
end;

function TSListItem.GetData: Pointer;
begin
  Result := FData;
end;

procedure TSListItem.SetData(Value: Pointer);
begin
  FData := Value;
end;

constructor TSListItem.Create;
begin
  inherited Create;
  
end;

destructor TSListItem.Destroy; 
begin
  //Free Data
  inherited Destroy;
end;  
  
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Hier endet die neue Implementation der Listen
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

type
  PBListItem = ^TBListItem;
  PSListItem = ^TSListItem;
///**
//	Basic List Item
//*/
  TBListItem = record
	Next: PBListItem;
	Prev: PBListItem;
	//SLIt: PSListItem
    //Data: Pointer;
  end;

{ .#define BLISTITEM(o) ((PBListItem)(o))}

///**
//	Simple List Item 
//*/
type 
  TSListItem = record
	o: PBListItem;
	Data: Pointer;
	//Link: PBListItem;     //hinzugefgt am 20.01.2016, war voher -> Data: Pointer
  end;
              7
{ .#define SLISTITEM(o) ((PSListItem)(o))}

///**
//	Basic and Simple List (identical) 
//*/
type 
  PBList = ^TBList
  TBList = record
	Last: PSListItem;
	Link: PSListItem;     //hinzugefgt am 20.01.2016
  end; 
  PSList = PBList;
  FreeProc = procedure (var Data: Pointer);

{ .#define BLIST(o) ((PBList)(o))}

procedure BListRemoveItemEx ( o: PBList; i: PBListItem );
function SListAdd ( o: PBList; var Data ): PSListItem;
function BListAddItem ( o: PBList; i: PBListItem ): PBListItem;
procedure FreeSList ( o: PBList; FreeData: FreeProc );
function NewBList ( ): PBList;
function SListFoundItem ( o: PBList; var Data ): PSListItem;


function SListFoundItem ( o: PBList; var Data: Pointer ): PSListItem; inline;
var a,b: PSListItem; c: PSListItem;
begin
  if not Assigned( o^.Last ) then SListFoundItem := NIL;
  a := o^.Last^.o^.Next;
  b := o^.Last^.o^.Next;
  if Assigned( a ) do 
  while a<>nil do {vorher a<>b}
  begin
	if ( a^.Data = Data ) then begin SListFoundItem := a; break; end;
	a := a^.o.Next;
  end; 
  SListFoundItem := NIL;
end;

function NewBList ( ): PBList; inline;
var o: PBList;
begin
  New(o);
  o^.Last = NIL;
  NewBList := o;
end;

procedure FreeSList ( var o: PBList; FreeData: FreeProc ); inline;
var a,b,n: PSListItem;
begin
	if Assigned( o^.Last ) then
	begin
		a := o^.Last;
        b := o^.Last;
		while a<>nil do {vorher a<>b}
        begin 
			n := a^.o.Prev;
			//if ( FreeData && SLISTITEM(a)->Data ) FreeData(SLISTITEM(a)->Data);
			if Assigned(FreeData) then if Assigned(a^.Data) then FreeData(a^.Data);
			Dispose(a);
			a := n;
		end;
	end;
	Dispose(o);
end;

function BListAddItem ( o: PBList; i: PBListItem ): PBListItem; inline;
begin
	if Assigned( o^.Last ) then
	begin
		i^.Next := o^.Last^.o^.Next;
		i^.Prev := o^.Last^.o;
		o^.Last^.o^.Next^.Prev := i;
		o^.Last^.o^.Next := i;
		o^.Last^.o := i;
	end else 
	begin
		i^.Next := i;
		i^.Prev := i;
		o^.Last^.o := i;
	end;
	BListAddItem := i;
end;

function SListAdd ( o: PBList; var Data ): PSListItem; inline;
var
  i: PSListItem;
begin	
  //PSListItem i = (PSListItem)malloc(sizeof(TSListItem));
  New(i);
  i^.Data := Pointer(Data);
  i^.o := i;
  o^.Last := i;
  o^.Last^.o := i^.o
  //o^.Last^.SLIt := i;
  //BListAddItem(o,BLISTITEM(i));
    if Assigned( o^.Last ) then
  begin
	i^.o^.Next := o^.Last^.o^.Next;  //Ursprnglich nicht i^.Link, sondern nur i.
	i^.o^.Prev := o^.Last^.o;
	o^.Last^.o^.Next^.Prev := i^.o;
	o^.Last^.o^.Next := i^.o;
	o^.Last := i^.o;
  end else 
  begin
	i^.o^.Next = i^.o;
	i^.o^.Prev = i^.o;
	o^.Last^.o = i^.o;
  end;
  SListAdd := i;
end;

procedure BListRemoveItemEx ( o: PBList; i: PBListItem ) ; inline;
begin
  if ( i^.Next = i ) then
	  o^.Last := NIL;
    else 
    begin
	  i^.Next^.Prev := i^.Prev;
	  i^.Prev^.Next := i^.Next;
	  if ( o^.Last^.o = i ) o^.Last^.o := i^.Prev;
    end;
end;

type 
  TComparePT = function (p1, p2: Pointer): Longint;
  TCompareLI = function (p1, p2: PListItem): Longint;
  TFreeProc  = procedure (var p: Pointer);

  PListItem = ^TListItem;
  TListItem = record
	Next: PListItem;
	Prev: PListItem;
	Data: Pointer;
	
	DataType: l_ulong;
	char *Key;
	FreeData: TFreeProc;
  end;

  PList = ^TList;
  TList = record
	PListItem Last;
	PListItem Current;
  end;

function NewListItemEx   ( char *Key, void *Data, void (*FreeData) (void*), l_ulong DataType, l_ulong DataSize ): PListItem;
function NewListItem     ( char *Key, void *Data, void (*FreeData) (void*) ): PListItem;
function ListAddItem     ( o: PList; i: PListItem ): PListItem;
function ListAdd         ( o: PList; *Key: Char; var Data: Pointer; FreeData: TFreeProc ): PListItem;
function ListRemoveItem  ( o: PList; i: PListItem ): Byte;
function ListAtItem      ( o: PList; Index: Longword ): PListItem;
function ListAt          ( o: PList; Index: Longword ): Pointer;
function ListKeyItem     ( o: PList; *Key: Char ): PListItem;
function ListKey         ( o: PList; *Key: Char ): Pointer;
function ListKeyCaseItem     ( o: PList; *Key: Char ): PListItem;
function ListKeyCase         ( o: PList; *Key: Char ): Pointer;
function ListFoundItem   ( o: PList var Data: Pointer ): PListItem;
function NewList         (  ): PList;
function ListFoundIndex ( o: PList; var Data: Pointer ): LongWord;
function ListAddItemBefore ( o: PList; i, b: PListItem ): PListItem;
function ListRemoveItemEx ( o: PList; i: PListItem ): Byte;

// /!\ This 2 functions dot no order Items in List, but Data /!\ ->-> To be improved ...
char       ListOrderByData ( o: PList; comparator: TComparePT );
char       ListOrderByItem ( o: PList; comparator: TCompareLI );

// free list, all items and data. Ideal for most uses.
procedure FreeList ( o: PList );

// Same as freelist but do not free data. (skip DataFree)
procedure KickList ( o: PList );

///#endif /* _LIST_H_INCLUDED_ */
