/////////////////////////////////////////////////////////////////////////////////
//
//	Volume Settings
//
//	Aura Milestone 3 
//
//	(c) Copyright 2012 Finn Technologies and Chase Finn. All rights reserved.
//
/////////////////////////////////////////////////////////////////////////////////

#include "kernel.h"
#include "widget.h"
#include "window.h"
#include "label.h"
#include "button.h"
#include "sound.h"
#include "slider.h"
#include "menu.h"
#include "checkbox.h"

l_ulong AppVersion	= ULONG_ID(0,0,0,1);
char    AppName[]	= "Volume";
l_uid	nUID		= "ap:vol";
l_uid NeededLibs[]	= { "widget", "mp3","sound","checkbox","" };

PWindow w;

////////////////////////////////////////////////////////////////////////////////
void SlideDigiNotify ( PSlider o, l_uchar Ctx, l_ulong Value ) {
	
	if ( Ctx == SCTX_SET ) {
		
		SetVolumeDigi(Value);
		
	}
	
}


l_int VolumeMute	= 0;

void Mute ( PWidget o )
{
	VolumeDigi = KeyGetInt("/USER/SOUND/VOLUMEDIGI",255);
	VolumeMidi = KeyGetInt("/USER/SOUND/VOLUMEMIDI",255);
	VolumeMute = KeyGetInt("/USER/SOUND/VOLUMEMUTE",0);	

		if (!CHECKBOX(o)->Checked)
		{
			VolumeMute = 0;
			KeySetInt("/USER/SOUND/VOLUMEMUTE",VolumeMute);
			set_volume(VolumeDigi,VolumeMidi);
		}
		else if (CHECKBOX(o)->Checked)
		{
			VolumeMute = 1;
			KeySetInt("/USER/SOUND/VOLUMEMUTE",VolumeMute);
			set_volume(0,0);
		}

}

l_bool MuteEventHandler ( PWidget o, PEvent Ev )
{
        if (Ev->Type == EV_MOUSE)
        {
                if (Ev->Message == WEvMouseLDown)
                {
                        CHECKBOX(o)->Checked = !CHECKBOX(o)->Checked;
                        WidgetDraw(o, NULL);
			Mute(o);
                        return true;
                }
        }

        return false;
}

////////////////////////////////////////////////////////////////////////////////
void SlideMidiNotify ( PSlider o, l_uchar Ctx, l_ulong Value ) {
	
	if ( Ctx == SCTX_SET ) {
		
		SetVolumeMidi(Value);
		
	}
	
}
////////////////////////////////////////////////////////////////////////////////

l_bool AppEventHandler ( PWidget o, PEvent Ev )
{
	if ( Ev->Type == EV_MESSAGE )
	{
		if ( Ev->Message == WM_CLOSE )
		{
			CloseApp(&Me);

			return true;
		}
		
	}
	return false;
}
////////////////////////////////////////////////////////////////////////////////
l_int Main ( int argc, l_text *argv )
{
	TRect r;
	PButton b = NULL;
	PSlider sl;
	PLabel l;
	PCheckbox chk;
	

	RectAssign(&r,0, 0, 255, 105);
	w = CreateWindow( &Me, r, "Volume", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 100, 15);
	l = CreateLabel(&Me, r, "Digital volume");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,5, 20, 250, 40);
	sl = CreateSlider(&Me,r,255);
	sl->Value = VolumeDigi;
	InsertWidget(WIDGET(w), WIDGET(sl));
	sl->Notify = &SlideDigiNotify;
	
	RectAssign(&r,5, 45, 250, 60);
	l = CreateLabel(&Me, r, "MIDI volume");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));

	
	RectAssign(&r,5, 65, 250, 85);
	sl = CreateSlider(&Me,r,255);
	sl->Value = VolumeMidi;
	InsertWidget(WIDGET(w), WIDGET(sl));
	sl->Notify = &SlideMidiNotify;

	RectAssign(&r,5, 90, 250, 100);
	chk = CreateCheckbox(&Me, r, "Mute");
	WIDGET(chk)->AppEvHdl = &MuteEventHandler;
	InsertWidget(WIDGET(w), WIDGET(chk));
	
	WidgetDrawAll(WIDGET(w));

	
	return true;
}

////////////////////////////////////////////////////////////////////////////////
void Close (void)
{
	WidgetDispose(WIDGET(w));
}
////////////////////////////////////////////////////////////////////////////////
