#include "kernel.h"
#include "widget.h"
#include "window.h"
#include "label.h"
#include "button.h"
#include "canvas.h"

l_ulong AppVersion	= ULONG_ID(0,0,0,1);
char    AppName[]	= "About";
l_uid	nUID		= "app:about";
l_uid NeededLibs[]	= { "widget", "button","label","window","" };

#define FWIDTH  420
#define FHEIGHT 220

PTask	MainTask = NULL;
PCanvas	c 	= 0;
PLabel l = 0;
PTimer t = 0;
l_ulong nb = 0, show = 2;
l_ubig ltime = 0;
PWindow w = 0;

p_bitmap Bmp1;
p_bitmap Bmp2;
p_bitmap Bmp3;
p_bitmap Bmp4;

void TimerPoll(void* A)
{
	nb++;
	if ( show == 1 && nb == 0x1300 ) nb = 0;
	if ( show == 2 && nb > 0xD00 ) {
		/*WIDGET(w)->Alpha = (nb & 0xFF);
		if ( WIDGET(w)->Alpha == 0xFF ) {*/
			CloseWindow(w);
		/*} else
			WidgetDrawAll(WIDGET(w));*/
		return;
	}
	WidgetDraw(WIDGET(c), NULL);
}


void FlameDraw (PWidget o, p_bitmap buffer, PRect w)
{
	rectfill(buffer,w->a.x,w->a.y,w->b.x,w->b.y,makecol(255,255,255));

	draw_sprite(buffer,Bmp1, (o->Absolute.a.x+o->Absolute.b.x-Bmp1->w)/2, (o->Absolute.a.y+o->Absolute.b.y-Bmp1->h)/2);
}

l_bool AppEventHandler ( PWidget o, PEvent Ev )
{
	if ( Ev->Type == EV_MESSAGE )
	{
		if ( Ev->Message == WM_CLOSE )
		{
			CloseApp(&Me);

			return true;
		}

	}

	return false;
}

l_int Main ( int argc, l_text *argv )
{
	TRect r;
	PButton b = NULL;

	if ( GSScreenDepth == 8 ) return false;
	
	if ( Me.Ressource ) {
		Bmp1 = ListKey(Me.Ressource,"1");
		Bmp2 = ListKey(Me.Ressource,"2");
		Bmp3 = ListKey(Me.Ressource,"3");
		Bmp4 = ListKey(Me.Ressource,"4");
	}

	if ( argc > 1 ) if ( !TextCompare(argv[1],"about") ) show = 1;

	RectAssign(&r,0, 0, FWIDTH, FHEIGHT);
	w = CreateWindow( &Me, r, "About", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;


	WidgetSize(&r,0, 0, FWIDTH, FHEIGHT);
	c = CreateCanvas(&Me, r);
	WIDGET(c)->Draw = &FlameDraw;
	WIDGET(c)->Flags |= WFForceBuffer;
	InsertWidget(WIDGET(w), WIDGET(c));

	WidgetDrawAll(WIDGET(w));


	t = NewTimer(&Me,10, &TimerPoll,NULL);
	return true;
}

void Close (void)
{
	KillTimer(t);
	WidgetDispose(WIDGET(w));
}
