#include "kernel.h"
#include "widget.h"
#include "window.h"
#include "label.h"
#include "button.h"
#include "canvas.h"
#include "tabbook.h"

l_ulong AppVersion	= ULONG_ID(0,0,0,2);
char    AppName[]	= "About";
l_uid	nUID		= "app:about";
l_uid NeededLibs[]	= { "widget", "button","label","window","tabbook","" };

#define FWIDTH  296
#define FHEIGHT 141


PCanvas	c 	= 0;
PLabel l = 0;
PWindow w = 0;

p_bitmap Bmp1;
p_bitmap Bmp2;

PTabBook bk;
PTab t;

void Draw1 (PWidget o, p_bitmap buffer, PRect w)
{
	draw_sprite(buffer,Bmp1, (o->Absolute.a.x+o->Absolute.b.x-Bmp1->w)/2, (o->Absolute.a.y+o->Absolute.b.y-Bmp1->h)/2);
	//blit(Bmp1, buffer, 0,0,0,0,(o->Absolute.a.x+o->Absolute.b.x-Bmp1->w)/2, (o->Absolute.a.y+o->Absolute.b.y-Bmp1->h)/2);
}

void Draw2 (PWidget o, p_bitmap buffer, PRect w)
{
	draw_sprite(buffer,Bmp2, (o->Absolute.a.x+o->Absolute.b.x-Bmp1->w)/2, (o->Absolute.a.y+o->Absolute.b.y-Bmp1->h)/2);
	//blit(Bmp2, buffer, 0,0,0,0,(o->Absolute.a.x+o->Absolute.b.x-Bmp1->w)/2, (o->Absolute.a.y+o->Absolute.b.y-Bmp1->h)/2);
}




l_bool AppEventHandler ( PWidget o, PEvent Ev )
{
	if ( Ev->Type == EV_MESSAGE )
	{
		if ( Ev->Message == WM_CLOSE )
		{
			CloseApp(&Me);

			return true;
		}

	}

	return false;
}

l_int Main ( int argc, l_text *argv )
{

	TRect r;
	PButton b = NULL;

	if ( Me.Ressource ) {
		Bmp1 = ListKey(Me.Ressource,"1");
		Bmp2 = ListKey(Me.Ressource,"2");
	}

	RectAssign(&r,0, 0, FWIDTH, FHEIGHT);
	w = CreateWindow( &Me, r, "About", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r, 0, 0, FWIDTH, FHEIGHT);
	bk = CreateTabBook(&Me,r);
	InsertWidget(WIDGET(w), WIDGET(bk));
	
	t = TabBookAddTab(bk,"System Information",NULL);

	WidgetSize(&r,0, 0, 296, 101);
	c = CreateCanvas(&Me, r);
	WIDGET(c)->Draw = &Draw1;
	WIDGET(c)->Flags |= WFForceBuffer;
	InsertWidget(WIDGET(t), WIDGET(c));

	t = TabBookAddTab(bk,"About Aura OS",NULL);

	WidgetSize(&r,0, 0, 296, 101);
	c = CreateCanvas(&Me, r);
	WIDGET(c)->Draw = &Draw2;
	WIDGET(c)->Flags |= WFForceBuffer;
	InsertWidget(WIDGET(t), WIDGET(c));



	WidgetDrawAll(WIDGET(w));


	return true;
}

void Close (void)
{

	WidgetDispose(WIDGET(w));
}
