/**
*	oZone example
*		(c) Copyright 2003,2004 Point Mad, Lukas Lipka. All rights reserved.
*
* Flamme algorithm by Kostas Michalopoulos aka Bad Sector
* 	Copyright (C) 2001,2002,2003 Kostas Michalopoulos
*
* Licenses
*   Algorithm : GNU General Public License (TimerPoll,NormalFlame,ColdFlame,GreenFlame)
*   Software  : Public domain
*
**/
////////////////////////////////////////////////////////////////////////////////
#include "kernel.h"
#include "widget.h"
#include "window.h"
#include "label.h"
#include "button.h"
#include "iodlg.h"
#include "console.h"
#include "textbox.h"

#include "mpeg2.h"
//#include "canvas.h"

//PCanvas	c 	= 0;
PLabel l = 0;
//PTimer t = 0;
PWindow w = 0;
PFileTypes Filter = 0;
char temp[400];

////////////////////////////////////////////////////////////////////////////////
l_ulong AppVersion = ULONG_ID(0,1,0,0);
char    AppName[] = "Convert MPEG";
l_uid	nUID = "convmpeg";
l_uid NeededLibs[] = { "widget", "button","label","window","mpeg2","conlib","mpg","textbox","" };
///////////////////////////////////////////////////////////////////////////////
l_bool AppEventHandler ( PWidget o, PEvent Ev ) {
	if ( Ev->Type == EV_MESSAGE ) {
		if ( Ev->Message == WM_CLOSE ) {
			CloseApp(&Me);
			return true;
		}
//		if ( Ev->Message == MSG_COLRED ) NormalFlame();
//		if ( Ev->Message == MSG_COLBLUE ) ColdFlame();
//		if ( Ev->Message == MSG_COLGREEN ) GreenFlame();
	}
	return false;
}
////////////////////////////////////////////////////////////////////////////////

static void save_pgm (int width, int height,
		      int chroma_width, int chroma_height,
		      uint8_t * const * buf, int num)
{
    char filename[100];
    PFile * pgmfile;
    int i;
    static uint8_t black[16384] = { 0 };

    sprintf (filename, "%d.pgm", num);
    pgmfile = FileOpen (filename, "wb");
    if (!pgmfile) {
     sprintf (temp, "Could not open file \"%s\".\n", filename);
     MessageBox(&Me, "Error", temp, MBB_OK);
     return;
    }
    else {
     //sprintf (temp, "Writing to tile %s...\n", filename);
     //MessageBox(&Me, "Info", temp, MBB_OK);
    }

    FilePrintf (pgmfile, "P5\n%d %d\n255\n",
	     2 * chroma_width, height + chroma_height);
    for (i = 0; i < height; i++) {
	FileWrite (buf[0] + i * width, width, 1, pgmfile);
	FileWrite (black, 2 * chroma_width - width, 1, pgmfile);
    }
    for (i = 0; i < chroma_height; i++) {
	FileWrite (buf[1] + i * chroma_width, chroma_width, 1, pgmfile);
	FileWrite (buf[2] + i * chroma_width, chroma_width, 1, pgmfile);
    }
    FileClose (pgmfile);
}

static void sample1 (PFile * mpgfile)
{

#define BUFFER_SIZE 4096
    uint8_t buffer[BUFFER_SIZE];
    mpeg2dec_t * decoder;
    const mpeg2_info_t * info;
    const mpeg2_sequence_t * sequence;
    mpeg2_state_t state;
    size_t size;
    int framenum = 0;

    decoder = mpeg2_init ();
    if (decoder == NULL) {
     sprintf (temp, "Could not allocate a decoder object.\n");
     MessageBox(&Me, "Error", temp, MBB_OK);
    return;
    }
    else {
//     sprintf (temp, "Started...\n");
//     MessageBox(&Me, "Info", temp, MBB_OK);
    }
    info = mpeg2_info (decoder);

    size = (size_t)-1;
    do {
	state = mpeg2_parse (decoder);
	sequence = info->sequence;
	switch (state) {
	case STATE_BUFFER:
	    size = FileRead (buffer, 1, BUFFER_SIZE, mpgfile);
	    mpeg2_buffer (decoder, buffer, buffer + size);
	    break;
	case STATE_SLICE:
	case STATE_END:
	case STATE_INVALID_END:
	    if (info->display_fbuf)
		save_pgm (sequence->width, sequence->height,
			  sequence->chroma_width, sequence->chroma_height,
			  info->display_fbuf->buf, framenum++);
	    break;
	default:
	    break;
	}
    } while (size);

    mpeg2_close (decoder);
}



////////////////////////////////////////////////////////////////////////////////
l_int Main( int argc, l_text *argv ) {
/*	TRect r;
	PButton b = NULL;

	RectAssign(&r,0, 0, FWIDTH+110, FHEIGHT);
	w = CreateWindow( &Me, r, "oZone example : Fire Effect", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	WidgetSize(&r,FWIDTH+5, 0, 100, 15);
	l = CreateLabel(&Me, r,"Color");
	InsertWidget(WIDGET(w), WIDGET(l));

	WidgetSize(&r,FWIDTH+15, r.b.y+2, 90, 20);
	b = CreateButton(&Me, r,"Normal",MSG_COLRED);
	InsertWidget(WIDGET(w), WIDGET(b));

	WidgetSize(&r,FWIDTH+15, r.b.y+2, 90, 20);
	b = CreateButton(&Me, r,"Blue",MSG_COLBLUE);
	InsertWidget(WIDGET(w), WIDGET(b));

	WidgetSize(&r,FWIDTH+15, r.b.y+2, 90, 20);
	b = CreateButton(&Me, r,"Green",MSG_COLGREEN);
	InsertWidget(WIDGET(w), WIDGET(b));

	WidgetSize(&r,FWIDTH+5, r.b.y+12, 100, 15);
	l = CreateLabel(&Me, r,"Statistics");
	InsertWidget(WIDGET(w), WIDGET(l));

	WidgetSize(&r,FWIDTH+15, r.b.y+2, 90, 15);
	l = CreateLabel(&Me, r,"");
	InsertWidget(WIDGET(w), WIDGET(l));

	NormalFlame();

	WidgetSize(&r,2, 1, FWIDTH-3, FHEIGHT-4);
	c = CreateCanvas(&Me, r);
	WIDGET(c)->Draw = &FlameDraw;
	WIDGET(c)->Flags |= WFForceNonBuffer;
	InsertWidget(WIDGET(w), WIDGET(c));

	WidgetDrawAll(WIDGET(w));

	t = NewTimer(&Me,0, &TimerPoll,NULL);
*/

Filter =        NewFileTypes("MPEG files (*.mpg)","mpg",
                                                NewFileTypes("All files",NULL,
                                                NULL ));


l_text file = IOBox("Open file",IOBOX_OPEN,NULL,Filter,true);
        if ( file ) {
          PFile f = FileOpen(file,"rb");
//          FILE *f = fopen(file,"rb");
          if ( f ) {
          sample1 (f);
          }
          else {
          sprintf (temp, "Cannot open %s...\n", file);
          MessageBox(&Me, "Error", temp, MBB_OK);
          }

          free(file);
        }

	return true;
}
////////////////////////////////////////////////////////////////////////////////
void Close( void ) {
WidgetDispose(WIDGET(w));
}
////////////////////////////////////////////////////////////////////////////////
