////////////////////////////////////////////////////////////////////////////////
//
//      Navigator 0.10
//              Aura File Explorer
//
//      (c) Copyright 2009 Chase Finn & Finn Technolgies. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
#include "kernel.h"
#include "widget.h"
#include "menu.h"
#include "button.h"
#include "window.h"
#include "treeview.h"
#include "iodlg.h"
#include "fms2.h"
#include "toolbar.h"

l_ulong AppVersion      = ULONG_ID(0,0,1,0);
char AppName[]          = "Navigator";
l_uid   nUID            = "app:nav";
l_uid NeededLibs[]      = { "menu", "treeview", "iodlg", "window", "" };

/**
 * Messages
 */
#define MSG_TREEVIEW_ONSEL      0x1256
#define MSG_DBLCLK                      0x2266
#define MSG_TB_GOUP                     0x4266

#define MSG_VIEWICONS           0x4267
#define MSG_VIEWLIST            0x4268
#define MSG_VIEWMOSC            0x4269
#define MSG_SORTBYNAME          0x426A
#define MSG_SORTBYSIZE          0x426B
#define MSG_SORTBYCTIME         0x426C
#define MSG_SORTBYATIME         0x426D
#define MSG_SORTBYMTIME         0x426E
#define MSG_POP         0x426F
/**
 * Widgets
 */
PTreeDirview t  = 0;
PDirview s      = 0;
PToolbar b      = 0;
PWindow w       = 0;
PMenu Menu	= 0;

l_bool AppEventHandler ( PWidget o, PEvent Event )
{
        if ( Event->Type == EV_MESSAGE )
        {
                switch ( Event->Message )
                {
                        case WM_CLOSE:
                        {
                                CloseApp(&Me);
                                return true;
                        }
                        break;

		 	case MSG_POP:
                	{
                        	TPoint p;
                        	PointAssign(&p,WIDGET(b)->Absolute.a.x, WIDGET(b)->Absolute.b.y);
                        	PopUpMenu(&Me, p, Menu, WIDGET(b), 0);
                        	return true;
               		}
                	break;

                        case WM_ABOUT:
                        {
                                MessageBox(&Me, "About Navigator", "Navigator \nAura file manager\n\nCopyright (c) 2008 Finn Technologies. All rights reserved.", MBB_OK);
                                return true;
                        }
                        break;

                        case MSG_IODLG_ITEMFILE_VAL:
                        {
                                if ( DIRVIEWITEM(Event->Extra)->f->Attributes & FA_DIREC )
                                {
    			    	return true;
                                }
                                else
                                {
                                        RunFile2(DIRVIEWITEM(Event->Extra)->f,0,NULL);
                                        return true;
                                }
                        }
                        break;

                        case MSG_TB_GOUP:
                        {
                                DirviewOpenParentDirectory(s);
                                return true;
                        }
                        break;

                        case MSG_VIEWICONS:
                        {
                                ListviewSetStyle(LISTVIEW(s),LVS_ICONS,0);
                                WidgetDrawAll(WIDGET(w));
                                return true;
                        }
                        break;
                        case MSG_VIEWLIST:
                        {
                                ListviewSetStyle(LISTVIEW(s),LVS_LIST,0);
                                WidgetDrawAll(WIDGET(w));
                                return true;
                        }
                        break;
                        case MSG_VIEWMOSC:
                        {
                                ListviewSetStyle(LISTVIEW(s),LVS_MOSC,0);
                                WidgetDrawAll(WIDGET(w));
                                return true;
                        }
                        break;
                        case MSG_SORTBYNAME:
                        {
    s->Flags &= ~(DVF_ORDERBYNAME|DVF_ORDERBYSIZE|DVF_ORDERBYCTIME|DVF_ORDERBYATIME|DVF_ORDERBYATIME);
    s->Flags |= DVF_ORDERBYNAME;
//    s->Flags = DVF_ORDERBYNAME|DVF_NOPARICON|DVF_MULTISELECT;
    DirviewRefreshData (s);
                                return true;
                        }
                        break;
                        case MSG_SORTBYSIZE:
                        {
    s->Flags &= ~(DVF_ORDERBYNAME|DVF_ORDERBYSIZE|DVF_ORDERBYCTIME|DVF_ORDERBYATIME|DVF_ORDERBYATIME);
    s->Flags |= DVF_ORDERBYSIZE;
//    s->Flags = DVF_ORDERBYSIZE|DVF_NOPARICON|DVF_MULTISELECT;
    DirviewRefreshData (s);
                                return true;
                        }
                        break;
                        case MSG_SORTBYCTIME:
                        {
    s->Flags &= ~(DVF_ORDERBYNAME|DVF_ORDERBYSIZE|DVF_ORDERBYCTIME|DVF_ORDERBYATIME|DVF_ORDERBYATIME);
    s->Flags |= DVF_ORDERBYCTIME;
//    s->Flags = DVF_ORDERBYCTIME|DVF_NOPARICON|DVF_MULTISELECT;
    DirviewRefreshData (s);
                                return true;
                        }
                        break;
                        case MSG_SORTBYMTIME:
                        {
    s->Flags &= ~(DVF_ORDERBYNAME|DVF_ORDERBYSIZE|DVF_ORDERBYCTIME|DVF_ORDERBYATIME|DVF_ORDERBYATIME);
    s->Flags |= DVF_ORDERBYMTIME;
//    s->Flags = DVF_ORDERBYMTIME|DVF_NOPARICON|DVF_MULTISELECT;
    DirviewRefreshData (s);
                                return true;
                        }
                        break;
                        case MSG_SORTBYATIME:
                        {
    s->Flags &= ~(DVF_ORDERBYNAME|DVF_ORDERBYSIZE|DVF_ORDERBYCTIME|DVF_ORDERBYATIME|DVF_ORDERBYATIME);
    s->Flags |= DVF_ORDERBYATIME;
//    s->Flags = DVF_ORDERBYATIME|DVF_NOPARICON|DVF_MULTISELECT;
    DirviewRefreshData (s);
                                return true;
                        }
                        break;
                }
        }

        return false;
}

l_int Main ( int argc, l_text *argv )
{
        TRect r;
        PWidget spl;

        RectAssign(&r,0, 0, 520, 380);
        w = CreateWindow(&Me, r, "Navigator", WF_NORMAL|WF_CENTERED|WF_RESIZE);
        WIDGET(w)->AppEvHdl = &AppEventHandler;
        InsertWidget(WIDGET(DeskTop), WIDGET(w));

        Menu = NewMenu(
     NewMenuItem( "File", NULL, NULL, NULL,
                 NewMenu (
                                /*NewMenuItem( "Open", NULL, NULL, NULL,
                                        NewMenu (
                                                NewMenuItem( "From HDD", NULL, NULL, NULL, NULL,
                                                NewMenuItem( "From WWW", NULL, NULL, NULL, NULL,
                                                NewMenuItem( "From FTP", NULL, NULL, NULL, NULL,
                                                NewMenuItem( "From RES", NULL, NULL, NULL, NULL,
                                                NULL))))
                                         ),*/
                                NewMenuItem( "Exit", NULL, WM_CLOSE, NULL, NULL, NULL)//)
                 ),
     NewMenuItem( "Edit", NULL, NULL, NULL, NULL,
     NewMenuItem( "View", NULL, NULL, NULL,
        NewMenu (
                                NewMenuItem( "Icons", NULL, MSG_VIEWICONS, NULL, NULL,
                                NewMenuItem( "List", NULL, MSG_VIEWLIST, NULL, NULL,
                                NewMenuItem( "Mosaic", NULL, MSG_VIEWMOSC, NULL, NULL,

                                NULL)))
                 ),
     NewMenuItem ("Sort by", NULL, NULL, NULL,
        NewMenu (
                                NewMenuItem( "Name", NULL, MSG_SORTBYNAME, NULL, NULL,
                                NewMenuItem( "Size", NULL, MSG_SORTBYSIZE, NULL, NULL,
                                NewMenuItem( "Creation Time", NULL, MSG_SORTBYCTIME, NULL, NULL,
                                NewMenuItem( "Access Time", NULL, MSG_SORTBYATIME, NULL, NULL,
                                NewMenuItem( "Modified Time", NULL, MSG_SORTBYMTIME, NULL, NULL,
                                NULL)))))
                 ),
     NewMenuItem( "Help", NULL, NULL, NULL,
        NewMenu(
                NewMenuItem( "About", NULL, WM_ABOUT, NULL, NULL, NULL)),
     NULL)))))
        );

        RectAssign(&r,0,0,500,20);
        PMenuView o = NewMenuView(&Me,r,Menu,MenuViewStyleHorizontal,0);
        InsertWidget(WIDGET(w), WIDGET(o));

        PToolbarItem ti;
        RectAssign(&r, 0,30,520,50);
        b = CreateToolbar(&Me, r);
        InsertWidget(WIDGET(w), WIDGET(b));

	ti = CreateToolbarItem("Options", LoadImage("./SYSTEM/ICONS/back.bmp"), MSG_POP, TI_TEXTUNDERICON);
        ToolbarAddItem(b,ti);
        ti = CreateToolbarItem("Up", LoadImage("./SYSTEM/ICONS/up.bmp"), MSG_TB_GOUP, TI_TEXTUNDERICON);
        ToolbarAddItem(b,ti);


        RectAssign(&r,0, 90, 520, 375);
        s = CreateDirview(&Me,r,"/",NULL,DVF_NOPARICON|DVF_MULTISELECT);
        WIDGET(s)->AppEvHdl = &AppEventHandler;
        WIDGET(s)->Flags |= WF_AUTORESIZE|WF_MAGNETRIGHT|WF_MAGNETBOTTOM;
        LISTVIEW(s)->Style = LVS_ICONS;
        InsertWidget(WIDGET(w), WIDGET(s));


        if ( argc > 1 ) {

                DirviewOpenDirectory(s,argv[1]);
        }

        WidgetDrawAll(WIDGET(w));

        return true;
}

void Close (void)
{
        WidgetDispose(WIDGET(w));
}
