

#include "kernel.h"
#include "widget.h"
#include "button.h"
#include "label.h"
#include "canvas.h"
#include "window.h"
#include "timer.h"
#include "iodlg.h"
#include "textbox.h"

#define BTN_Ok                  0x4267
#define BTN_Ok2                 0x4268
#define WBB_OK                  0x4269
#define BTN_Opn                0x4270


l_ulong UID			= ULONG_ID('O','R','C','H');
l_ulong AppVersion	= ULONG_ID(0,0,0,1);
char AppName[]		= "Aura Setup";
l_uid	nUID		= "app:aossetup";

_PUBLIC PCanvas Frame	= 0;
	TRect r, wr;
	PButton b;
	PLabel l;
	PWindow w	= 0;
	PFileTypes Filter = 0;
PTextbox ext;

l_bool AppEventHandler ( PWidget o, PEvent Event )
{
	if ( Event->Type == EV_MESSAGE )
	{
		switch ( Event->Message )
		{
			case WM_CLOSE:
			{
				WidgetDispose(WIDGET(o));
				CloseApp(&Me);
				return true;
			}
			break;
			case BTN_Ok:
			{
				CollectingData();
				return true;
			}
			break;
			case BTN_Opn:
			{
			l_text newmedia = IOBox("Install Location", IOBOX_SAVE, NULL, Filter, false);
				if ( newmedia ) {
					TextBoxSetText(ext,"\"%s\"",newmedia);
					free(newmedia);
				}
				return;
			}
			break;
			
		}
	}

	return false;
}


void CollectingData( void )
{
	Filter = 	NewFileTypes("DynLd executable","app,dl",
				NewFileTypes("All files",NULL,
				NULL ));

	RectAssign(&r,0, 0, 255, 255);
	w = CreateWindow( &Me, r, "Aura Setup", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 250, 15);
	l = CreateLabel(&Me, r, "Where do you want Aura Installed?");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,5, 20, 250, 35);
	l = CreateLabel(&Me, r, "Only install in root of drive if root is empty");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,5, 40, 250, 55);
	l = CreateLabel(&Me, r, "");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));

	RectAssign(&r,5, 55, 250, 70);
	l = CreateLabel(&Me, r, "Enter install location (e.g. /C/ ");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));

	RectAssign(&r, 5, 75, 250, 90);
	ext = CreateTextbox(&Me,r,TBF_EDITABLE);
	InsertWidget(WIDGET(w), WIDGET(ext));

	RectAssign(&r,200, 95, 250, 115);
	b = CreateButton(&Me,r,"Next",BTN_Opn);
	InsertWidget(WIDGET(w), WIDGET(b));
	
	RectAssign(&r,200, 230, 250, 250);
	b = CreateButton(&Me,r,"Next",BTN_Ok);
	InsertWidget(WIDGET(w), WIDGET(b));
	
	WidgetDrawAll(WIDGET(w));

	return;
}

l_int Main ( int argc, l_text *argv )
{
	RectAssign(&r,0, 0, 255, 255);
	w = CreateWindow( &Me, r, "Aura Setup", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 250, 15);
	l = CreateLabel(&Me, r, "Welcome To the Aura Setup");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,5, 20, 250, 35);
	l = CreateLabel(&Me, r, "This Setup will install Aura OS (Milestone 1 | 1080)");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,5, 40, 250, 55);
	l = CreateLabel(&Me, r, "Click Next to begin");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,200, 230, 250, 250);
	b = CreateButton(&Me,r,"Next",BTN_Ok);
	InsertWidget(WIDGET(w), WIDGET(b));
	
	WidgetDrawAll(WIDGET(w));

	return true;
}

void Close (void)
{

}
