

#include "kernel.h"
#include "widget.h"
#include "button.h"
#include "label.h"
#include "canvas.h"
#include "window.h"
#include "timer.h"
#include "iodlg.h"
#include "textbox.h"

#define BTN_Ok                  0x4267
#define BTN_Ok2                 0x4268
#define WBB_OK                  0x4269
#define MSG_TREEVIEW_ONSEL      0x1256
#define MSG_select		        0x1257
#define MSG_doinstall		        0x1258
#define MSG_completeinstall		        0x1259
#define CB_SEL		        0x1259
#define CB_FILTER       0xFF00FFB0


l_ulong UID			= ULONG_ID('O','R','C','H');
l_ulong AppVersion	= ULONG_ID(0,0,0,1);
char AppName[]		= "Aura Setup";
l_uid	nUID		= "app:aossetup";

_PUBLIC PCanvas Frame	= 0;
	TRect r, wr;
	PButton b;
	PButton a = 0;
	PButton c = 0;
	PLabel l;
	PWindow w	= 0;
	PTreeDirview t  = 0;
	PTextbox ext;
        PProgressPop p;

l_bool AppEventHandler ( PWidget o, PEvent Event )
{
	if ( Event->Type == EV_MESSAGE )
	{
		switch ( Event->Message )
		{
			case WM_CLOSE:
			{
				WidgetDispose(WIDGET(o));
				CloseApp(&Me);
				return true;
			}
			break;
			case BTN_Ok:
			{
				CollectingData();
				return true;
			}
			break;
			case MSG_doinstall:
			{
				Install();
				return true;
			}
			case MSG_completeinstall:
			{		
				PList j;
				l_text abc = "/System/main.exe";
				PListItem ab = abc;
				l_text acc = "/System/kernel.txt";
				PListItem ac = acc;
				l_text adc = "/System/kernel.sys";
				PListItem ad = adc;

				CopyFilesFromList ( j, "/System/user/music/" );
				return true;
			}
			break;
			case MSG_select:
			{
			TextBoxSetText(ext,"\"%s\"",TREEDIRVIEWITEM(TREEVIEW(t)->Sel)->f->VPathName);
			}						
		}
	}

	return false;
}

void Install( void )
{
	RectAssign(&r,0, 0, 255, 255);
	w = CreateWindow( &Me, r, "Aura Setup", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 250, 15);
	l = CreateLabel(&Me, r, "Installing Aura OS...");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
		
	RectAssign(&r,5, 20, 195, 35);
	l = CreateLabel(&Me, r, "*DO NOT TURN OFF YOUR COMPUTER*");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));

	RectAssign(&r,200, 230, 250, 250);
	b = CreateButton(&Me,r,"Next",MSG_completeinstall);
	InsertWidget(WIDGET(w), WIDGET(b));

	WidgetDrawAll(WIDGET(w));

	return;
}

void CollectingData( void )
{

	RectAssign(&r,0, 0, 255, 255);
	w = CreateWindow( &Me, r, "Aura Setup", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 250, 15);
	l = CreateLabel(&Me, r, "Where do you want Aura Installed?");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	
	RectAssign(&r,5, 25, 250, 40);
	l = CreateLabel(&Me, r, "Enter install location (e.g. \"/C/system\")");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));

	RectAssign(&r, 5, 45, 250, 60);
	ext = CreateTextbox(&Me,r,TBF_EDITABLE);
	InsertWidget(WIDGET(w), WIDGET(ext));

        RectAssign(&r,5, 65, 250, 190);
        t = CreateTreeDirview(&Me,r);
        WIDGET(t)->Flags |= WF_AUTORESIZE|WF_MAGNETBOTTOM|WF_MAGNETRIGHT;
        InsertWidget(WIDGET(w), WIDGET(t));

	RectAssign(&r,5, 195, 195, 225);
	l = CreateLabel(&Me, r, "Click folder then click select");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));

	RectAssign(&r,200, 195, 250, 225);
	b = CreateButton(&Me,r,"Select",MSG_select);
	InsertWidget(WIDGET(w), WIDGET(b));

	RectAssign(&r,200, 230, 250, 250);
	b = CreateButton(&Me,r,"Next",MSG_doinstall);
	InsertWidget(WIDGET(w), WIDGET(b));
	
	WidgetDrawAll(WIDGET(w));

	return;
}

l_int Main ( int argc, l_text *argv )
{
	RectAssign(&r,0, 0, 255, 255);
	w = CreateWindow( &Me, r, "Aura Setup", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 250, 15);
	l = CreateLabel(&Me, r, "Welcome To the Aura Setup");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,5, 20, 250, 35);
	l = CreateLabel(&Me, r, "This Setup will install Aura OS (Milestone 1 | 1080)");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,5, 40, 250, 55);
	l = CreateLabel(&Me, r, "Click Next to begin");
	WIDGET(l)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(l));
	
	RectAssign(&r,200, 230, 250, 250);
	b = CreateButton(&Me,r,"Next",BTN_Ok);
	InsertWidget(WIDGET(w), WIDGET(b));
	
	WidgetDrawAll(WIDGET(w));

	return true;
}

void Close (void)
{

}
