

#include "kernel.h"
#include "widget.h"
#include "button.h"
#include "label.h"
#include "canvas.h"
#include "window.h"
#include "timer.h"
#include "iodlg.h"
#include "textbox.h"

#define BTN_Ok                  0x4267
#define BTN_Ok2                 0x4268
#define WBB_OK                  0x4269
#define MSG_TREEVIEW_ONSEL      0x1256
#define MSG_select		        0x1257
#define MSG_doinstall		        0x1258
#define CB_SEL		        0x1259
#define CB_FILTER       0xFF00FFB0


l_ulong UID			= ULONG_ID('O','R','C','H');
l_ulong AppVersion	= ULONG_ID(0,0,0,1);
char AppName[]		= "Aura Setup";
l_uid	nUID		= "app:aossetup";

_PUBLIC PCanvas Frame	= 0;
	TRect r, wr;
	PButton b;
	PButton a = 0;
	PButton c = 0;
	PLabel j;
	PWindow w	= 0;
	PTreeDirview t  = 0;
	PTextbox ext;
        PProgressPop p;

l_bool AppEventHandler ( PWidget o, PEvent Event )
{
	if ( Event->Type == EV_MESSAGE )
	{
		switch ( Event->Message )
		{
			case WM_CLOSE:
			{
				WidgetDispose(WIDGET(o));
				CloseApp(&Me);
				return true;
			}
			break;
			case BTN_Ok:
			{
				CollectingData();
				return true;
			}
			break;
			case MSG_doinstall:
			{
				Install();
				return true;
			}
			break;
			case MSG_select:
			{
			TextBoxSetText(ext,"\"%s\"",TREEDIRVIEWITEM(TREEVIEW(t)->Sel)->f->VPathName);
			}						
		}
	}

	return false;
}

l_bool FileCopier ( PFile s, PFile d ) {
        l_char Buffer[4096];
        l_int r = 0;
        while ( !FileEOF(s) ) {
                r = FileRead(&Buffer,1,4096,s);
                SysPoll();
                FileWrite(&Buffer,1,r,d);
                SysPoll();
        }
        if ( WIDGET(p->W)->MessageBuffer == WM_CLOSE ) return false;
        return true;
}

void CopyFilesFromList ( PList l, l_text Dest ) {
// here is a bug! crashs pc if drag n drop of directories... Florian Xaver

if ( l->Last ) {
        l_ulong GlobalSize = 0;

        PListItem a = l->Last->Next, b = a;
        l_bool Ignore = false, ReplaceAll = false;
        l_ulong SamePlace = 0;

        do {
                PFileRef r = FILEREF(a->Data);

                if ( r->Attributes & FA_DIREC )
                        GlobalSize += 1;
                else
                        GlobalSize += r->Size/1024;

                a = a->Next;
        } while ( a != b );

        DebugMessage("Copying files...");

        do {
                PFileRef r = FILEREF(a->Data);
                l_text Out = SamePlace ? NULL : FileNameToPath(Dest,r->SName);
                PFileInfo of = ( ReplaceAll || SamePlace ) ? NULL : FileGetInfo(Out);

                SysPoll();

                Ignore = false;

                if ( of ) {

                        if ( of->Drive == r->Drive && !TextCompare(of->LocalName,r->LocalName) ) {
                                l_text NewSName = TextArgs("Copy of %s",r->SName);
                                free(Out);
                                FreeFileInfo(of);
                                SamePlace = 1;
                                Out = FileNameToPath(Dest,NewSName);
                                free(NewSName);
                                while ( of = FileGetInfo(Out) ) {
                                        free(Out);
                                        FreeFileInfo(of);
                                        NewSName = TextArgs("Copy(%d) of %s",SamePlace-1,r->SName);
                                        Out = FileNameToPath(Dest,NewSName);
                                        free(NewSName);
                                        SamePlace++;
                                }
                        } else {

                                l_text text = TextArgs("File %s (%d bytes) yet exists.\nDo you want to replace it with %s (%d bytes) ?",Out,of->Size,r->SName,r->Size);
                                l_ulong msg = MessageBox(&Me,"I/O",text,MBB_YESYESALLNOCANCEL);

                                if ( msg == MSG_CANCEL ) break;
                                if ( msg == MSG_NO ) Ignore = true;
                                if ( msg == MSG_YESALL ) ReplaceAll = true;

                                free(text);
                                FreeFileInfo(of); of = NULL;

                        }
                }

                if ( !Ignore ) {

                if ( SamePlace ) {
                        l_text NewSName;
                        if ( SamePlace > 1 )
                                NewSName = TextArgs("Copy(%d) of %s",SamePlace-1,r->SName);
                        else
                                NewSName = TextArgs("Copy of %s",r->SName);
                        Out = FileNameToPath(Dest,NewSName);
                }


                if ( r->Attributes & FA_DIREC ) {
                        MakeDir(Out);
                        SysPoll();
                } else if ( r->Drive->Driver->FileOpen ) {
                        PFile s = 0;
                        PFile d = 0;
                        s = r->Drive->Driver->FileOpen(r->Drive,r->LocalName,"rb");
                        d = FileOpen(Out,"wb");
                        if ( d && s ) {
                                FileCopier(s,d);
                        }       else
                        {
                                DebugMessage ("Couldn't copy file - reason unknown! :-(");
                        }
                        if ( s ) FileClose(s);
                        if ( d ) FileClose(d);
                        DebugMessage ("File is copied!");


                }

                }
                if (Out)  {free(Out); Out = 0;}
                if ( WIDGET(p->W)->MessageBuffer == WM_CLOSE ) break;
                a = a->Next;
        } while ( a != b );

        }
}


void Install( void )
{
	RectAssign(&r,0, 0, 255, 255);
	w = CreateWindow( &Me, r, "Aura Setup", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 250, 15);
	j = CreateLabel(&Me, r, "Installing Aura OS...");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));
		
	RectAssign(&r,5, 20, 195, 35);
	j = CreateLabel(&Me, r, "*DO NOT TURN OFF YOUR COMPUTER*");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));

	RectAssign(&r,5, 45, 195, 60);
	j = CreateLabel(&Me, r, "Applications");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));

	RectAssign(&r,5, 60, 195, 75);
	j = CreateLabel(&Me, r, "Libraries");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));

	RectAssign(&r,5, 75, 195, 90);
	j = CreateLabel(&Me, r, "User Interface");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));

	RectAssign(&r,5, 90, 195, 105);
	j = CreateLabel(&Me, r, "Kernel");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));	
	
	RectAssign(&r,200, 230, 250, 250);
	b = CreateButton(&Me,r,"Next",MSG_doinstall);
	InsertWidget(WIDGET(w), WIDGET(b));
	
	WidgetDrawAll(WIDGET(w));


	RectAssign(&r,60, 45, 195, 65);
	j = CreateLabel(&Me, r, "...");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));
	WidgetDrawAll(WIDGET(w));

        PList  l = NULL;
	ListDir ( "/SYSTEM/Applications", NULL );
	CopyFilesFromList (l, "/SYSTEM/USER/MUSIC");
	
	RectAssign(&r,65, 45, 195, 75);
	j = CreateLabel(&Me, r, "Done");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));
	WidgetDrawAll(WIDGET(w));


	return;
}

void CollectingData( void )
{

	RectAssign(&r,0, 0, 255, 255);
	w = CreateWindow( &Me, r, "Aura Setup", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 250, 15);
	j = CreateLabel(&Me, r, "Where do you want Aura Installed?");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));
	
	
	RectAssign(&r,5, 25, 250, 40);
	j = CreateLabel(&Me, r, "Enter install location (e.g. \"/C/system\")");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));

	RectAssign(&r, 5, 45, 250, 60);
	ext = CreateTextbox(&Me,r,TBF_EDITABLE);
	InsertWidget(WIDGET(w), WIDGET(ext));

        RectAssign(&r,5, 65, 250, 190);
        t = CreateTreeDirview(&Me,r);
        WIDGET(t)->Flags |= WF_AUTORESIZE|WF_MAGNETBOTTOM|WF_MAGNETRIGHT;
        InsertWidget(WIDGET(w), WIDGET(t));

	RectAssign(&r,5, 195, 195, 225);
	j = CreateLabel(&Me, r, "Click folder then click select");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));

	RectAssign(&r,200, 195, 250, 225);
	b = CreateButton(&Me,r,"Select",MSG_select);
	InsertWidget(WIDGET(w), WIDGET(b));

	RectAssign(&r,200, 230, 250, 250);
	b = CreateButton(&Me,r,"Next",MSG_doinstall);
	InsertWidget(WIDGET(w), WIDGET(b));
	
	WidgetDrawAll(WIDGET(w));

	return;
}

l_int Main ( int argc, l_text *argv )
{
	RectAssign(&r,0, 0, 255, 255);
	w = CreateWindow( &Me, r, "Aura Setup", WF_FRAME|WF_CAPTION|WF_MINIMIZE|WF_CENTERED );
	InsertWidget(DeskTop, WIDGET(w));
	WIDGET(w)->AppEvHdl = &AppEventHandler;

	RectAssign(&r,5, 0, 250, 15);
	j = CreateLabel(&Me, r, "Welcome To the Aura Setup");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));
	
	RectAssign(&r,5, 20, 250, 35);
	j = CreateLabel(&Me, r, "This Setup will install Aura OS (Milestone 1 | 1080)");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));
	
	RectAssign(&r,5, 40, 250, 55);
	j = CreateLabel(&Me, r, "Click Next to begin");
	WIDGET(j)->BackgroundColor = COL_3DFACE;
	InsertWidget(WIDGET(w), WIDGET(j));
	
	RectAssign(&r,200, 230, 250, 250);
	b = CreateButton(&Me,r,"Next",BTN_Ok);
	InsertWidget(WIDGET(w), WIDGET(b));
	
	WidgetDrawAll(WIDGET(w));

	return true;
}

void Close (void)
{

}
